<?php 
$controller = 'Waste';
$action = '';
if(isset($_POST['action'])){
    $action = $_POST['action'];
    if (isset($_POST['id'])) {$id = $_POST['id'];}
}elseif(isset($_GET['action'])){
    $action = $_GET['action'];
    if (isset($_GET['id'])) {$id = $_GET['id'];}
}
include $_SERVER["DOCUMENT_ROOT"].'/app/include/bootstrap.php';

$venta = new VentaEntity();
$login = new Login();

if($action == '' && !$venta->cajaAbierta($login->getToken())){
    header("Location: Register.php?w");
}

$_form = new WasteForm();
$_waste = new WasteRepository();
$_listaWaste = $_waste->getListaWaste();

switch($action){
    case 'insert':
        $_form->populate($_POST);
        if($_form->isValid()){
            $_waste->setOptions($_POST);
            $result = $_waste->save($_waste->getOptions());
            if($result){
                $flashmessenger->addMessage(array('success'=>'La Merma ha sido registrado exitosamente.'));
                header('Location: Waste.php');
            }else{
                $flashmessenger->addMessage(array('danger'=>'Algo salio mal al intentar registrar Merma. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
            }
        }else{
            $_listaWaste = $_waste->getListaWaste();
            $vista = 'Waste.php';
            include $root.'/View/Template.php';
        }
        break;
   
    case 'edit':
        if($_GET){$_wasteData = $_waste->getById($id);}
        if($_POST){$_wasteData = $_POST;}
        
        $_form->setActionController('edit');
        $_form->setId($id);
        $_form->populate($_wasteData);
        
        $_listaWaste = $_waste->getListaWaste();
        
        if(isset($_POST['id'])){
            if($_form->isValid()){
                $_waste->setOptions($_wasteData);
                $result = $_waste->update($id,$_waste->getOptions()); //no tengo id porque viene de post
                if($result){
                    $flashmessenger->addMessage(array('success'=>'La Merma ha actualizado exitosamente.'));
                    header("Location: Waste.php?action=edit&id=$id");
                }else{
                    $flashmessenger->addMessage(array('danger'=>'Algo salio mal al intenta actualizar la merma. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
                }       
            }else{
                $vista = 'Waste.php';
                include $root . '/View/Template.php';
            }
        }else{
            $vista = 'Waste.php';
            include $root . '/View/Template.php';
        }        
        break;
    
    case 'delete': 
        if(!$_waste->isUsedInRecord($id)){
            if($_waste->delete($id)){
                $flashmessenger->addMessage(array('success'=>'La Merma fue eliminada satisfactoriamente.'));                
            }
        }else{
            $message = 'Esta Merma no puede ser eliminada, esta siendo utilizada en almenos un registro.';
            $flashmessenger->addMessage(array('info'=>$message));
        }
        header('Location: Waste.php');
        break;    
    
    default:
        $_listaWaste = $_waste->getListaWaste();
        $vista = 'Waste.php';
        include $root.'/View/Template.php';
}